"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var enums_1 = require("./enums");
var package_json_1 = require("../package.json");
var maxLatencyDataPoints = 14;
var PieClient = /** @class */ (function () {
    function PieClient(_a) {
        var _this = this;
        var _b = _a.env, env = _b === void 0 ? 'development' : _b;
        this.onClose = function () {
            console.log("Pie: pie-client: connection closed.");
            _this._updateDebugInfo();
            // If client is accepting the onConnectInfo callback,
            // send the message to it
            if (_this.onConnectInfo) {
                _this.onConnectInfo({
                    type: enums_1.MessageType.ConnectInfo,
                    connected: _this.isConnected(),
                    msg: "Connection to ".concat(_this.ws && _this.ws.url, " closed.")
                });
            }
        };
        this.tryReconnect = function () {
            // Try reconnect
            clearTimeout(_this.reconnectTimeoutId);
            var tryReconnectAgainInMillis = 100 + Math.pow(_this.reconnectAttempts, 2) * 50;
            console.log("Pie: pie-client: Reconnect attempt ".concat(_this.reconnectAttempts +
                1, "; will try to reconnect automatically in ").concat(tryReconnectAgainInMillis, " milliseconds."));
            _this.reconnectTimeoutId = setTimeout(function () {
                if (_this.ws && _this.ws.url) {
                    _this.connect(_this.ws.url, _this.useStats);
                }
                else {
                    console.error('Cannot attempt to reconnect, this.ws has no url');
                }
            }, tryReconnectAgainInMillis);
            // Increment reconenctAttempts since successful connect
            _this.reconnectAttempts++;
        };
        console.log("Pie: WebSocketPie Client v".concat(package_json_1.version, " ").concat(env));
        this.env = env;
        this.onError = console.error;
        this.soloMode = false;
        this.reconnectAttempts = 0;
        this.promiseCBs = {
            joinRoom: undefined
        };
        this.useStats = false;
        this.currentClientId = '';
        // Optionally support a connection status element
        this.statusElement = document.querySelector('#websocket-pie-connection-status');
        if (this.statusElement) {
            this.statusElement = this.statusElement;
            this.statusElement.style['pointerEvents'] = 'none';
            this.statusElement.style['position'] = 'absolute';
            this.statusElement.style['top'] = '10px';
            this.statusElement.style['left'] = '10px';
            this.statusElement.style['userSelect'] = 'none';
        }
        this.stats = {
            latency: {
                min: Number.MAX_SAFE_INTEGER,
                max: 0,
                averageDataPoints: [],
                average: NaN
            }
        };
    }
    // See https://developer.mozilla.org/en-US/docs/Web/API/WebSocket/readyState
    PieClient.prototype.isConnected = function () {
        return this.soloMode || !!this.ws && this.ws.readyState == this.ws.OPEN;
    };
    PieClient.prototype.connect = function (wsUrl, useStats) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                // Only connect if there is no this.ws object or if the current this.ws socket is CLOSED
                if (this.ws && this.ws.readyState !== this.ws.CLOSED) {
                    console.error('Pie: pie-client: Cannot create a new connection.  Please fully close the existing connection before attempting to open a new one');
                    return [2 /*return*/];
                }
                this.soloMode = false;
                this.useStats = useStats;
                console.log("Pie: pie-client: connecting to ".concat(wsUrl, "..."));
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.ws = new WebSocket(wsUrl);
                        _this._updateDebugInfo();
                        _this.ws.onmessage = function (event) {
                            try {
                                var message = JSON.parse(event.data);
                                // Disregard messages from self, since they are returned to the self client immediately
                                // to prevent input lag
                                if (message.fromClient !== _this.currentClientId) {
                                    _this.handleMessage(message, useStats);
                                }
                            }
                            catch (e) {
                                console.error(e);
                                if (_this.onError) {
                                    _this.onError(e);
                                }
                            }
                        };
                        _this.ws.onopen = function () {
                            console.log("Pie: pie-client: connected!");
                            _this._updateDebugInfo();
                            // If client is accepting the onConnectInfo callback,
                            // send the message to it
                            if (_this.onConnectInfo) {
                                _this.onConnectInfo({
                                    type: enums_1.MessageType.ConnectInfo,
                                    connected: _this.isConnected(),
                                    msg: "Opened connection to ".concat(_this.ws && _this.ws.url)
                                });
                            }
                            if (_this.currentRoomInfo) {
                                console.log("Pie: Rejoining room", _this.currentRoomInfo);
                                _this.joinRoom(_this.currentRoomInfo, true);
                            }
                            // Reset reconnect attempts now that the connection is successfully opened
                            _this.reconnectAttempts = 0;
                            if (_this.ws) {
                                _this.ws.addEventListener('close', _this.tryReconnect);
                            }
                            resolve();
                        };
                        _this.ws.onerror = function (err) {
                            console.error('pie-client error:', err);
                            // There may be other errors than just one during
                            // connection attempt but in the event that 
                            // the error occurs during the connection attempt
                            // it will reject the connection promise
                            reject();
                        };
                        // Always invoke this.onClose() when the socket is closed
                        _this.ws.addEventListener('close', _this.onClose);
                    })];
            });
        });
    };
    PieClient.prototype.connectSolo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var clientFakeId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // Disconnect if currently connected so we can fake a singleplayer connection
                    return [4 /*yield*/, this.disconnect()];
                    case 1:
                        // Disconnect if currently connected so we can fake a singleplayer connection
                        _a.sent();
                        this.soloMode = true;
                        this.ws = undefined;
                        if (this.onConnectInfo) {
                            this.onConnectInfo({
                                type: enums_1.MessageType.ConnectInfo,
                                connected: this.isConnected(),
                                msg: "\"Connected\" in solo mode"
                            });
                        }
                        this._updateDebugInfo();
                        clientFakeId = 1;
                        // Fake serverAssignedData
                        this.handleMessage({
                            type: enums_1.MessageType.ServerAssignedData,
                            clientId: clientFakeId,
                            serverVersion: "no server - client is in solomode"
                        }, false);
                        // Fake clientPresenceChanged
                        this.handleMessage({
                            clients: [clientFakeId],
                            clientThatChanged: clientFakeId,
                            time: Date.now(),
                            type: enums_1.MessageType.ClientPresenceChanged,
                            present: true
                        }, false);
                        return [2 /*return*/];
                }
            });
        });
    };
    PieClient.prototype.disconnect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                console.log('Pie: pie-client: Disconnecting...');
                return [2 /*return*/, new Promise(function (resolve) {
                        if (_this.soloMode) {
                            _this.soloMode = false;
                            resolve();
                            return;
                        }
                        if (!_this.ws || _this.ws.readyState == _this.ws.CLOSED) {
                            // Resolve immediately, client is already not connected 
                            resolve();
                            return;
                        }
                        else {
                            // Do NOT try to reconnect after close since we are
                            // intentionally closing the socket
                            _this.ws.removeEventListener('close', _this.tryReconnect);
                            // Resolve this promise when the connection is finally closed
                            _this.ws.addEventListener('close', function () {
                                resolve();
                            });
                            // Close the connection
                            _this.ws.close();
                            // Updates debug info to show that it is closing
                            _this._updateDebugInfo();
                        }
                    }).then(function () {
                        // Updates debug info to show that it is closed
                        _this._updateDebugInfo();
                        console.log('Pie: pie-client: Successfully disconnected.');
                    })];
            });
        });
    };
    PieClient.prototype.handleMessage = function (message, useStats) {
        if (useStats && message.time) {
            var currentMessageLatency = Date.now() - message.time;
            if (currentMessageLatency > this.stats.latency.max) {
                this.stats.latency.max = currentMessageLatency;
            }
            if (currentMessageLatency < this.stats.latency.min) {
                this.stats.latency.min = currentMessageLatency;
            }
            this.stats.latency.averageDataPoints.push(currentMessageLatency);
            if (this.stats.latency.averageDataPoints.length > maxLatencyDataPoints) {
                // Remove the oldest so the averageDataPoints array stays a fixed size
                this.stats.latency.averageDataPoints.shift();
                this.stats.latency.average =
                    this.stats.latency.averageDataPoints.reduce(function (acc, cur) { return acc + cur; }, 0) /
                        this.stats.latency.averageDataPoints.length;
                // Broadcast latency information
                if (this.onLatency) {
                    this.onLatency(this.stats.latency);
                }
            }
        }
        switch (message.type) {
            case enums_1.MessageType.Data:
                if (this.onData) {
                    this.onData(message);
                }
                break;
            case enums_1.MessageType.ResolvePromise:
                var funcNameForResolve = message.func;
                var promiseCbRes = this.promiseCBs[funcNameForResolve];
                if (promiseCbRes) {
                    promiseCbRes.resolve(message.data);
                }
                break;
            case enums_1.MessageType.RejectPromise:
                var funcNameForReject = message.func;
                var promiseCbRej = this.promiseCBs[funcNameForReject];
                if (promiseCbRej) {
                    promiseCbRej.reject(message.err);
                }
                break;
            case enums_1.MessageType.ServerAssignedData:
                this.currentClientId = message.clientId;
                if (this.onServerAssignedData) {
                    this.onServerAssignedData(message);
                }
                break;
            case enums_1.MessageType.ClientPresenceChanged:
                this._updateDebugInfo(message);
                // If client is accepting the onClientPresenceChanged callback,
                // send the message to it
                if (this.onClientPresenceChanged) {
                    this.onClientPresenceChanged(message);
                }
                break;
            case enums_1.MessageType.Rooms:
                if (this.onRooms) {
                    this.onRooms(message);
                }
                break;
            case enums_1.MessageType.Err:
                console.error(message);
                if (this.onError) {
                    this.onError(message);
                }
                break;
            default:
                console.log('Pie:', message);
                console.error("Pie: Above message of type ".concat(message.type, " not recognized!"));
        }
    };
    PieClient.prototype.makeRoom = function (roomInfo) {
        this.joinRoom(roomInfo, true);
    };
    PieClient.prototype.joinRoom = function (roomInfo, makeRoomIfNonExistant) {
        var _this = this;
        if (makeRoomIfNonExistant === void 0) { makeRoomIfNonExistant = false; }
        if (this.isConnected()) {
            // Cancel previous makeRoom promise if it exists
            // @ts-ignore
            if (this.promiseCBs[enums_1.MessageType.JoinRoom]) {
                // @ts-ignore
                this.promiseCBs[enums_1.MessageType.JoinRoom].reject({ message: "Cancelled due to newer ".concat(enums_1.MessageType.JoinRoom, " request") });
            }
            return new Promise(function (resolve, reject) {
                // Assign callbacks so that the response from the server can
                // fulfill this promise
                // @ts-ignore
                _this.promiseCBs[enums_1.MessageType.JoinRoom] = { resolve: resolve, reject: reject };
                if (_this.ws) {
                    _this.ws.send(JSON.stringify({
                        type: enums_1.MessageType.JoinRoom,
                        roomInfo: roomInfo,
                        makeRoomIfNonExistant: makeRoomIfNonExistant
                    }));
                }
                if (_this.isConnected() && _this.ws === undefined) {
                    // solo mode, resolve immediately
                    resolve(roomInfo);
                }
            }).then(function (currentRoomInfo) {
                if (typeof currentRoomInfo.app === 'string' && typeof currentRoomInfo.name === 'string' && typeof currentRoomInfo.version === 'string') {
                    console.log("Pie: ".concat(enums_1.MessageType.JoinRoom, " successful with"), currentRoomInfo);
                    // Save roomInfo to allow auto rejoining should the server restart
                    _this.currentRoomInfo = currentRoomInfo;
                }
                else {
                    console.error("Pie: joinRoom succeeded but currentRoomInfo is maleformed:", currentRoomInfo);
                }
            });
        }
        else {
            return Promise.reject({ message: "".concat(enums_1.MessageType.JoinRoom, " failed, not currently connected to web socket server") });
        }
    };
    PieClient.prototype.leaveRoom = function () {
        if (this.isConnected() && this.ws) {
            this.ws.send(JSON.stringify({
                type: enums_1.MessageType.LeaveRoom
            }));
            this.currentRoomInfo = undefined;
        }
        else {
            if (this.onError) {
                this.onError({ message: "Cannot leave room, not currently connected to web socket server" });
            }
        }
    };
    PieClient.prototype.getRooms = function (roomInfo) {
        if (this.isConnected() && this.ws) {
            this.ws.send(JSON.stringify({
                type: enums_1.MessageType.GetRooms,
                roomInfo: roomInfo
            }));
        }
        else {
            if (this.onError) {
                this.onError({ message: "Cannot get rooms, not currently connected to web socket server" });
            }
        }
    };
    PieClient.prototype.sendData = function (payload, extras) {
        if (this.isConnected()) {
            var message = __assign({ type: enums_1.MessageType.Data, payload: payload }, extras);
            if (this.ws !== undefined) {
                this.ws.send(JSON.stringify(message));
            }
            if (!extras || extras.subType === undefined) {
                // Handle own message immediately to reduce lag
                // Only handle own message immediately if there is no subtype.  Otherwise it
                // would process Whisper or Together messages immediately which it shouldn't.
                this.handleMessage(__assign({ fromClient: this.currentClientId }, message), false);
            }
        }
        else {
            if (this.onError) {
                this.onError({ message: "Cannot send data to room, not currently connected to web socket server" });
            }
        }
    };
    PieClient.prototype._updateDebugInfo = function (message) {
        try {
            if (this.statusElement) {
                if (this.ws && this.ws.readyState == this.ws.CONNECTING) {
                    this.statusElement.innerHTML = "\u2B24 Connecting...";
                }
                else if (this.isConnected()) {
                    if (this.soloMode) {
                        this.statusElement.innerHTML = "\u2B24 Connected in solo mode";
                    }
                    else if (this.ws && this.ws.readyState == this.ws.OPEN) {
                        var numberOfClients = (message && message.clients && message.clients.length) || 1;
                        this.statusElement.innerHTML = "\u2B24 ".concat(numberOfClients == 1 ? "".concat(numberOfClients, " User") : "".concat(numberOfClients, " Users"), " Connected");
                    }
                }
                else if (this.ws && this.ws.readyState == this.ws.CLOSED) {
                    this.statusElement.innerHTML = "\u2B24 Disconnected";
                }
                else if (this.ws && this.ws.readyState == this.ws.CLOSING) {
                    this.statusElement.innerHTML = "\u2B24 Disconnecting...";
                }
                else {
                    this.statusElement.innerHTML = "\u2B24 Not Connected";
                }
                this.statusElement.style.color = this.soloMode || (this.ws && (this.ws.readyState == this.ws.OPEN || this.ws.readyState == this.ws.CONNECTING)) ? 'green' : 'red';
            }
        }
        catch (e) {
            console.error(e);
        }
    };
    return PieClient;
}());
exports["default"] = PieClient;
